SIMULATOR(1)

NAME
simulator - GNU simulator for AVR

SYNOPSIS
avr-run [options] [VAR=VAL|--] program [program args]

OPTIONS

-t[on|off], --trace[=on|off]
    Trace useful things

--trace-insn[=on|off]
    Perform instruction tracing

--trace-disasm[=on|off]
    Disassemble instructions (slower, but more accurate)

--trace-decode[=on|off]
    Trace instruction decoding

--trace-extract[=on|off]
    Trace instruction extraction

--trace-linenum[=on|off]
    Perform line number tracing (implies --trace-insn)

--trace-memory[=on|off]
    Trace memory operations

--trace-alu[=on|off]
    Trace ALU (Arithmetic Logic Unit) operations

--trace-fpu[=on|off]
    Trace FPU (Floating Point Unit) operations

--trace-vpu[=on|off]
    Trace VPU (Vector Processing Unit) operations

--trace-branch[=on|off]
    Trace branching

--trace-semantics[=on|off]
    Perform ALU, FPU, VPU, MEMORY, and BRANCH tracing

--trace-model[=on|off]
    Include model performance data

--trace-core[=on|off]
    Trace core operations

--trace-events[=on|off]
    Trace events

--trace-syscall[=on|off]
    Trace system calls

--trace-register[=on|off]
    Trace cpu register accesses

--trace-debug[=on|off]
    Add information useful for debugging the simulator to the tracing output

--trace-file FILE NAME
    Specify tracing output file

-p[on|off], --profile[=on|off]
    Perform profiling

--profile-insn[=on|off]
    Perform instruction profiling

--profile-memory[=on|off]
    Perform memory profiling

--profile-core[=on|off]
    Perform CORE profiling

--profile-model[=on|off]
    Perform model profiling

--profile-cpu-frequency CPU FREQUENCY
    Specify the speed of the simulated cpu clock

--profile-file FILE NAME
    Specify profile output file

--profile-pc[=on|off]
    Perform PC profiling

-F PC PROFILE FREQUENCY, --profile-pc-frequency PC PROFILE FREQUENCY
    Specified PC profiling frequency

-S PC PROFILE SIZE, --profile-pc-size PC PROFILE SIZE
    Specify PC profiling size

--profile-pc-granularity PC PROFILE GRANULARITY
    Specify PC profiling sample coverage

--profile-pc-range BASE,BOUND
    Specify PC profiling address range

--hw-info, --info-hw
    List configurable hw regions

--hw-trace[=on|off], --trace-hw
    Trace all hardware devices

--hw-device DEVICE
    Add the specified device

--hw-list
    List the device tree

--hw-file FILE
    Add the devices listed in the file

--sockser-addr SOCKET ADDRESS
    Set serial emulation socket address

--watch-cycles-ACTION [+]COUNT
    Watch the simulator, take ACTION in COUNT cycles (`+' for every COUNT cycles), ACTION is int breakpoint

--watch-pc-ACTION [!]ADDRESS
    Watch the PC, take ACTION when matches ADDRESS (in range ADDRESS,ADDRESS), `!' negates test

--watch-clock-ACTION [+]MILLISECONDS
    Watch the clock, take ACTION after MILLISECONDS (`+' for every MILLISECONDS)

--watch-delete IDENT|all|pc|cycles|clock
    Delete a watchpoint

--watch-info
    List scheduled watchpoints

--memory-delete ADDRESS|all, --delete-memory ADDRESS
    Delete memory at ADDRESS (all addresses)

--memory-region ADDRESS,SIZE[,MODULO]
    Add a memory region

--memory-alias ADDRESS,SIZE{,ADDRESS}
    Add memory shadow

--memory-size <size>[in bytes, Kb (k suffix), Mb (m suffix) or Gb (g suffix)]
    Add memory at address zero

--memory-fill VALUE
    Fill subsequently added memory regions

--memory-clear
    Clear subsequently added memory regions

--memory-mapfile FILE
    Memory-map next memory region from file

--memory-info, --info-memory
    List configurable memory regions

--map-info
    List mapped regions

--model MODEL
    Specify model to simulate

--model-info, --info-model
    List selectable models

-v, --verbose
    Verbose output

-E B|big|L|little, --endian B|big|L|little
    Set endianness

--environment user|virtual|operating
    Set running environment

--alignment strict|nonstrict|forced
    Set memory access alignment

-D, --debug
    Print debugging messages

--debug-insn
    Print instruction debugging messages

--debug-file FILE NAME
    Specify debugging output file

--do-command COMMAND

-h, --help
    Print help information

--version
    Print version information

--architecture MACHINE
    Specify the architecture to use

--architecture-info, --info-architecture
    List supported architectures

--target BFDNAME
    Specify the object-code format for the object files

--target-info, --info-target
    List supported targets

--load-{lma,vma}
    Use VMA or LMA addresses when loading image (default LMA)

--sysroot SYSROOT
    Root for system calls with absolute file-names and cwd at start

--argv0 ARGV0
    Set argv[0] to the specified string

--env-set VAR=VAL
    Set the variable in the program's environment

--env-unset VAR
    Unset the variable in the program's environment

--env-clear
    Clear the program's environment

Note: Depending on the simulator configuration some options

    may not be applicable

VAR=VAL Environment variables to set. Ignored if -- is used. program args Arguments to pass to simulated program.

    Note: Very few simulators support this.

COPYRIGHT
Copyright © 2023 Free Software Foundation, Inc. License GPLv3+: GNU GPL version 3 or later <https://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law.

SEE ALSO
The full documentation for simulator is maintained as a Texinfo manual. If the info and simulator programs are properly installed at your site, the command

    info simulator

should give you access to the complete manual.